const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const import_mappings = sequelize.define(
    'import_mappings',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

description: {
        type: DataTypes.TEXT,
      
      

      },

is_active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

is_default: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  import_mappings.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity












    db.import_mappings.hasMany(db.mapping_rules, {
      as: 'mapping_rules_mapping',
      foreignKey: {
          name: 'mappingId',
      },
      constraints: false,
    });













//end loop



    db.import_mappings.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.import_mappings.belongsTo(db.data_entities, {
      as: 'data_entity',
      foreignKey: {
        name: 'data_entityId',
      },
      constraints: false,
    });

    db.import_mappings.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.import_mappings.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.import_mappings.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return import_mappings;
};


